using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record class SortingContainer : Properties.ISortingContainer
{

    public Face Face { init; get; }
    public Sorting Sorting { init; get; }

    [JsonConstructor]
    public SortingContainer(Face face, Sorting sorting)
    {
        Face = face;
        Sorting = sorting;
    }

    public override string ToString()
    {
        string result = string.Concat(Face.Mapping?.MappingFromItem.Id, '\t', Face.Mapping?.MappingFromLocation.NormalizedPixelPercentage, '\t', Sorting.Id, '\t', Sorting.NormalizedPixelPercentage, '\t', Sorting.Older, '\t', Sorting.WithinRange, '\t', Sorting.DistancePermyriad, '\t', Sorting.DaysDelta);
        return result;
    }

}