namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IMapping
{ // ...

    (string?, string?, string?, bool?) TestStatic_GetSegments(string facesFileNameExtension, string fileName)
        => GetSegments(facesFileNameExtension, fileName);
    static (string?, string?, string?, bool?) GetSegments(string facesFileNameExtension, string fileName)
        => Mapping.GetSegments(facesFileNameExtension, fileName);

    string TestStatic_GetDeterministicHashCodeKey(int id, Models.Location location, int locationDigits, int locationFactor, OutputResolution outputResolution)
        => GetDeterministicHashCodeKey(id, location, locationDigits, locationFactor, outputResolution);
    static string GetDeterministicHashCodeKey(int id, Models.Location location, int locationDigits, int locationFactor, OutputResolution outputResolution)
        => $"{id}.{ILocation.GetLeftPadded(locationDigits, ILocation.GetNormalizedPixelPercentage(location, locationDigits, locationFactor, outputResolution))}";

    (int?, int?, List<Models.Face>?) TestStatic_GetReversedDeterministicHashCodeKey(string facesFileNameExtension, string file) =>
        GetReversedDeterministicHashCodeKey(facesFileNameExtension, file);
    static (int?, int?, List<Models.Face>?) GetReversedDeterministicHashCodeKey(string facesFileNameExtension, string file) =>
        Mapping.GetReversedDeterministicHashCodeKey(facesFileNameExtension, false, new(), file);

    (int?, int?, List<Models.Face>?) TestStatic_GetReversedDeterministicHashCodeKey(string facesFileNameExtension, bool idToFacesAny, Dictionary<int, List<Models.Face>> idToFaces, string file) =>
        GetReversedDeterministicHashCodeKey(facesFileNameExtension, idToFacesAny, idToFaces, file);
    static (int?, int?, List<Models.Face>?) GetReversedDeterministicHashCodeKey(string facesFileNameExtension, bool idToFacesAny, Dictionary<int, List<Models.Face>> idToFaces, string file) =>
        Mapping.GetReversedDeterministicHashCodeKey(facesFileNameExtension, idToFacesAny, idToFaces, file);

}