namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPersonBirthday
{

    DateTime TestStatic_GetDefaultValue() =>
        PersonBirthday.GetDefaultValue(); // {{1}}SingletonValue

    static DateTime GetDefaultValue() =>
        PersonBirthday.GetDefaultValue(); // {{1}}SingletonValue

    // ...

    double? TestStatic_GetAge(Models.PersonBirthday birthday) =>
        GetAge(birthday);
    static double? GetAge(Models.PersonBirthday birthday) =>
        PersonBirthday.GetAge(birthday);

    DateTime? TestStatic_GetDateTime(string personBirthdayFormat, string personKey) =>
        PersonBirthday.GetDateTime(personBirthdayFormat, personKey);
    static DateTime? GetDateTime(string personBirthdayFormat, string personKey) =>
        PersonBirthday.GetDateTime(personBirthdayFormat, personKey);

    Models.PersonBirthday TestStatic_GetPersonBirthday(long ticks) =>
        new(new(ticks));
    static Models.PersonBirthday GetPersonBirthday(long ticks) =>
        new(new(ticks));

    string TestStatic_GetFileName(string personBirthdayFormat, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileName(personBirthdayFormat, personBirthday);
    static string GetFileName(string personBirthdayFormat, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileName(personBirthdayFormat, personBirthday);

    (int, TimeSpan) TestStatic_GetAge(DateTime dateTime, Models.PersonBirthday birthday) =>
        GetAge(dateTime, birthday);
    static (int, TimeSpan) GetAge(DateTime dateTime, Models.PersonBirthday birthday) =>
        PersonBirthday.GetAge(dateTime, birthday);

    (int, TimeSpan) TestStatic_GetAge(long dateTimeTicks, Models.PersonBirthday birthday) =>
        GetAge(dateTimeTicks, birthday);
    static (int, TimeSpan) GetAge(long dateTimeTicks, Models.PersonBirthday birthday) =>
        PersonBirthday.GetAge(dateTimeTicks, birthday);

    string TestStatic_GetFormatted(string personBirthdayFormat, long personKey) =>
        GetFormatted(personBirthdayFormat, personKey);
    static string GetFormatted(string personBirthdayFormat, long personKey) =>
        PersonBirthday.GetFormatted(personBirthdayFormat, GetPersonBirthday(personKey));

    string TestStatic_GetFormatted(string personBirthdayFormat, Models.PersonBirthday personBirthday) =>
        GetFormatted(personBirthdayFormat, personBirthday);
    static string GetFormatted(string personBirthdayFormat, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFormatted(personBirthdayFormat, personBirthday);

    Models.PersonBirthday? TestStatic_GetPersonBirthday(string personBirthdayFormat, string personKey) =>
        GetPersonBirthday(personBirthdayFormat, personKey);
    static Models.PersonBirthday? GetPersonBirthday(string personBirthdayFormat, string personKey) =>
        PersonBirthday.GetPersonBirthday(personBirthdayFormat, personKey);

    bool TestStatic_IsCounterPersonBirthday(Models.PersonBirthday personBirthday) =>
        IsCounterPersonBirthday(personBirthday);
    static bool IsCounterPersonBirthday(Models.PersonBirthday personBirthday) =>
        PersonBirthday.IsCounterPersonBirthday(personBirthday);

    Models.PersonBirthday TestStatic_GetNextBirthDate(Properties.IStorage storage) =>
        GetNextBirthDate(storage);
    static Models.PersonBirthday GetNextBirthDate(Properties.IStorage storage) =>
        PersonBirthday.GetNextBirthDate(storage);

    TimeSpan? TestStatic_Get(DateTime minimumDateTime, Models.PersonBirthday personBirthday) =>
        GetTimeSpan(minimumDateTime, isWrongYear: false, personBirthday);
    static TimeSpan? GetTimeSpan(DateTime minimumDateTime, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(minimumDateTime, isWrongYear: false, personBirthday);

    TimeSpan? TestStatic_Get(long minimumDateTimeTicks, bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        GetTimeSpan(minimumDateTimeTicks, isWrongYear, personBirthday);
    static TimeSpan? GetTimeSpan(long minimumDateTimeTicks, bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(minimumDateTimeTicks, isWrongYear, personBirthday);

    string TestStatic_GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.PersonBirthday personBirthday) =>
        GetFileFullName(storage, personBirthdayFormat, personBirthday);
    static string GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetFileFullName(storage, personBirthdayFormat, personBirthday);

    bool TestStatic_DoesBirthDateExits(Properties.IStorage storage, Models.PersonBirthday personBirthday) =>
        DoesBirthDateExits(storage, personBirthday);
    static bool DoesBirthDateExits(Properties.IStorage storage, Models.PersonBirthday personBirthday) =>
        DoesBirthDateExits(storage, personBirthday);

    TimeSpan? TestStatic_Get(DateTime minimumDateTime, bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        GetTimeSpan(minimumDateTime, isWrongYear, personBirthday);
    static TimeSpan? GetTimeSpan(DateTime minimumDateTime, bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        PersonBirthday.GetTimeSpan(minimumDateTime, isWrongYear, personBirthday);

    bool TestStatic_IsWrongYearFilterOrCounterPersonBirthday(bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        IsWrongYearFilterOrCounterPersonBirthday(isWrongYear, personBirthday);
    static bool IsWrongYearFilterOrCounterPersonBirthday(bool? isWrongYear, Models.PersonBirthday personBirthday) =>
        PersonBirthday.IsWrongYearFilterOrCounterPersonBirthday(isWrongYear, personBirthday);

}